void tblcf_usb_init(void);
void tblcf_usb_find_devices(unsigned short int product_id);
unsigned int tblcf_usb_cnt(void);
unsigned char tblcf_usb_open(unsigned int device_no);
void tblcf_usb_close(void);
unsigned char tblcf_usb_send_ep0(unsigned char * data);
unsigned char tblcf_usb_recv_ep0(unsigned char * data);
unsigned char tblcf_usb_send_ep2(unsigned char * data);
unsigned char tblcf_usb_recv_ep2(unsigned char * data);

/* in circuit programming */
#define ICP_MAX_PACKET_SIZE		64
#define ICP_VERIFY				0x87
#define ICP_MASS_ERASE			0x83
#define ICP_BLOCK_ERASE			0x82
#define ICP_GET_RESULT			0x8F
#define ICP_RESULT_OK			0x01
#define ICP_RESULT_BUSY			0x02
#define ICP_RESULT_FAIL			0x04
#define ICP_PROGRAM				0x81
#define ICP_FLASH_BLOCK_SIZE	512		/* must be power of 2 */


char icp_verify(unsigned char * data, unsigned int address, unsigned int count);
char icp_program(unsigned char * data, unsigned int address, unsigned int count);
char icp_mass_erase(void);
char icp_block_erase(unsigned int address);

